ScarfHilbertAlgorithm Class Reference

`#include <ScarfHilbertAlgorithm.h>`

## Classes

struct | State

## Public Member Functions

| ScarfHilbertAlgorithm (const TermTranslator &translator, const ScarfParams &params, unique_ptr< IdealOrderer > enumerationOrder, unique_ptr< IdealOrderer > deformationOrder)
| ~ScarfHilbertAlgorithm ()
void | runGeneric (const Ideal &ideal, CoefBigTermConsumer &consumer, bool univariate, bool canonical)

## Private Member Functions

void | enumerateScarfComplex (const Ideal &ideal, CoefTermConsumer &consumer)
void | initializeEnumeration (const Ideal &ideal, size_t &activeStateCount)
bool | doEnumerationStep (const Ideal &ideal, const IdealTree &tree, State &state, State &nextState)
void | doEnumerationBaseCase (const State &state, CoefTermConsumer &consumer)

## Private Attributes

vector< State > | _states
const TermTranslator & | _translator
const ScarfParams & | _params
const unique_ptr< IdealOrderer > | _enumerationOrder
const unique_ptr< IdealOrderer > | _deformationOrder
size_t | _totalStates
size_t | _totalFaces

## Detailed Description

Definition at line 32 of file ScarfHilbertAlgorithm.h.

## Constructor & Destructor Documentation

## ScarfHilbertAlgorithm()

ScarfHilbertAlgorithm::ScarfHilbertAlgorithm | ( | const TermTranslator & | translator,
|  | const ScarfParams & | params,
|  | unique_ptr< IdealOrderer > | enumerationOrder,
|  | unique_ptr< IdealOrderer > | deformationOrder )

Definition at line 92 of file ScarfHilbertAlgorithm.cpp.

## ~ScarfHilbertAlgorithm()

ScarfHilbertAlgorithm::~ScarfHilbertAlgorithm | ( |  | ) |

Definition at line 107 of file ScarfHilbertAlgorithm.cpp.

## Member Function Documentation

## doEnumerationBaseCase()

void ScarfHilbertAlgorithm::doEnumerationBaseCase | ( | const State & | state,
|  | CoefTermConsumer & | consumer )

private

Definition at line 238 of file ScarfHilbertAlgorithm.cpp.

## doEnumerationStep()

bool ScarfHilbertAlgorithm::doEnumerationStep | ( | const Ideal & | ideal,
|  | const IdealTree & | tree,
|  | State & | state,
|  | State & | nextState )

private

Definition at line 174 of file ScarfHilbertAlgorithm.cpp.

## enumerateScarfComplex()

void ScarfHilbertAlgorithm::enumerateScarfComplex | ( | const Ideal & | ideal,
|  | CoefTermConsumer & | consumer )

private

Definition at line 254 of file ScarfHilbertAlgorithm.cpp.

## initializeEnumeration()

void ScarfHilbertAlgorithm::initializeEnumeration | ( | const Ideal & | ideal,
|  | size_t & | activeStateCount )

private

Definition at line 141 of file ScarfHilbertAlgorithm.cpp.

## runGeneric()

void ScarfHilbertAlgorithm::runGeneric | ( | const Ideal & | ideal,
|  | CoefBigTermConsumer & | consumer,
|  | bool | univariate,
|  | bool | canonical )

Definition at line 112 of file ScarfHilbertAlgorithm.cpp.

## Member Data Documentation

## _deformationOrder

const unique_ptr<IdealOrderer> ScarfHilbertAlgorithm::_deformationOrder

private

Definition at line 68 of file ScarfHilbertAlgorithm.h.

## _enumerationOrder

const unique_ptr<IdealOrderer> ScarfHilbertAlgorithm::_enumerationOrder

private

Definition at line 67 of file ScarfHilbertAlgorithm.h.

## _params

const ScarfParams& ScarfHilbertAlgorithm::_params

private

Definition at line 66 of file ScarfHilbertAlgorithm.h.

## _states

vector<State> ScarfHilbertAlgorithm::_states

private

Definition at line 52 of file ScarfHilbertAlgorithm.h.

## _totalFaces

size_t ScarfHilbertAlgorithm::_totalFaces

private

Definition at line 71 of file ScarfHilbertAlgorithm.h.

## _totalStates

size_t ScarfHilbertAlgorithm::_totalStates

private

Definition at line 70 of file ScarfHilbertAlgorithm.h.

## _translator

const TermTranslator& ScarfHilbertAlgorithm::_translator

private

Definition at line 65 of file ScarfHilbertAlgorithm.h.

The documentation for this class was generated from the following files:

- src/ScarfHilbertAlgorithm.h
- src/ScarfHilbertAlgorithm.cpp